"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Hooks = void 0;

class Hooks {
  constructor() {
    this.hooks = new Map();
    this.pluginHooks = new Map();
  }

  add(hook) {
    const hooks = this.hooks.get(hook.key) || [];
    this.hooks.set(hook.key, hooks.concat(hook));

    if (hook.pluginId) {
      this.pluginHooks.set(hook.pluginId, (this.pluginHooks.get(hook.pluginId) || []).concat(hook));
    }

    return true;
  }

  find(key) {
    return this.pluginHooks.has(key) ? this.pluginHooks.get(key) : [].concat(this.hooks.get(key) || []);
  }

}

exports.Hooks = Hooks;